<template>
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-8">
                <div class="card display-flex">
                    <div class="card-header">Create prescription</div>

                    <div class="card-body">
                        <div class="alert alert-danger" role="alert" v-if="error">
                            {{ error }}
                        </div>
                        <form action="#" @submit.prevent="submit">
                            <div class="form-group row">
                                <label for="drug" class="col-md-4 col-form-label text-md-right">Drugs</label>

                                <v-select id="drug"
                                          v-model="selectDrug"
                                          :filterable="false"
                                          :options="drugs"
                                          @search="fetchDrugs">
                                    <template slot="no-options">
                                        type 3 letters to search...
                                    </template>
                                    <template v-slot:option="drug">
                                        <div v-html="drug.name"></div>
                                    </template>
                                    <template v-slot:selected-option="drug">
                                        <div v-html="drug.name"></div>
                                    </template>
                                </v-select>
                            </div>

                            <div class="form-group row">
                                <label for="user" class="col-md-4 col-form-label text-md-right">Patient</label>

                                <v-select id="user"
                                          v-model="selectedUser"
                                          :filterable="false"
                                          :options="users"
                                          @search="fetchUsers">
                                    <template slot="no-options">
                                        type 3 letters to search...
                                    </template>
                                    <template v-slot:option="user">
                                        <div v-html="user.email"></div>
                                    </template>
                                    <template v-slot:selected-option="user">
                                        <div v-html="user.email"></div>
                                    </template>
                                </v-select>
                            </div>

                            <div class="form-group row">
                                <label for="description" class="col-md-4 col-form-label text-md-right">Description</label>

                                <div class="col-md-6">
                                    <input id="description" type="text" class="form-control" name="text" v-model="description">
                                </div>
                            </div>

                            <div class="form-group row mb-0">
                                <div class="col-md-8 offset-md-4">
                                    <button type="submit" class="btn btn-primary">
                                        Submit
                                    </button>
                                </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import axios from 'axios';
import configs from './../../config'
import VSelect from 'vue-select';

export default {
    components: { VSelect },
    data () {
        return {
            error: null,
            selectedUser: null,
            selectDrug: null,
            description: null,
            drugs: [],
            users: [],
        }
    },

    methods: {
        fetchUsers(search) {
            if (search.length >= 3) {
                this.loading = true;
                axios
                    .get(configs.PATIENTS_URL + `/${search}`)
                    .then(response => {
                        this.loading = false;
                        this.users = response.data;
                    })
                    .catch(error => {
                        this.loading = false;
                        this.error = error.response.data.message || error.message;
                    });
            }
        },

        fetchDrugs(search) {
            if (search.length >= 3) {
                this.loading = true;
                axios
                    .get(configs.DRUGS_URL + `/${search}`)
                    .then(response => {
                        this.loading = false;
                        this.drugs = response.data;
                    })
                    .catch(error => {
                        this.loading = false;
                        this.error = error.response.data.message || error.message;
                    });
            }
        },

        submit() {
            this.loading = true;
            let form = {
                drug_id: this.selectDrug.id,
                user_id: this.selectedUser.id,
                description: this.description
            }
            axios
                .post(configs.PRESCRIPTIONS_URL, form)
                .then(response => {
                    window.location.href = configs.PRESCRIPTIONS_URL;
                })
                .catch(error => {
                    this.loading = false;
                    this.error = error.response.data.message || error.message;
                });
        }
    }
}
</script>
